﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;

namespace ctshml5Exception
{
    public class RestHelper
    {
        public static string GetStringBetweenKeywords(string text, string firstKeyword, string secondKeyword,
                                                      bool keepKeywords = false)
        {
            try
            {
                var position1 = GetFirstPositionOfKeyword(text, firstKeyword);
                if (position1 == -1) return string.Empty;

                position1 = CheckToKeepKeywordPos1(firstKeyword, keepKeywords, position1);
                var position2 = SetEndPosition(text, secondKeyword, position1);

                position2 = CheckToKeeyKeywordPos2(secondKeyword, keepKeywords, position2);
                if (position1 < 0 || position2 < 0)
                    return String.Empty;

                var extractedText = ExtractTextBetweenPos1AndPos2(text, position1, position2);
                MessageBox.Show("Extracted text: " + extractedText);
                return extractedText;
            }

            catch (Exception e)
            {
                MessageBox.Show("GetStringBetweenKeywords: " + e.Message);
                return string.Empty;
            }
        }

        private static string ExtractTextBetweenPos1AndPos2(string text, int position1, int position2)
        {
            var x = text.Substring(position1, position2 - position1);
            return x;
        }

        private static int CheckToKeeyKeywordPos2(string secondKeyword, bool keepKeywords, int position2)
        {
            if (keepKeywords)
                position2 = position2 + secondKeyword.Length;
            return position2;
        }

        private static int SetEndPosition(string text, string secondKeyword, int position1)
        {
            var position2 = text.IndexOf(secondKeyword, position1 + 1);
            return position2;
        }

        private static int CheckToKeepKeywordPos1(string firstKeyword, bool keepKeywords, int position1)
        {
            if (!keepKeywords)
                position1 = position1 + firstKeyword.Length;
            return position1;
        }

        private static int GetFirstPositionOfKeyword(string text, string firstKeyword)
        {
            var position1 = text.IndexOf(firstKeyword);
            return position1;
        }

        public static List<string> GetAllStringsBetweenKeywords(string text, string firstKeyword, string secondKeyword,
                                                                bool keepKeywords = false)
        {
            var list = new List<string>();
            var splt = SplitTextByKeyword(text, firstKeyword);
            RemoveFirstEntryIfNotKeywordStarting(text, firstKeyword, splt);

            var str = firstKeyword + splt[0];
            list.Add(GetStringBetweenKeywords(str, firstKeyword, secondKeyword, keepKeywords));
            return list;
        }

        private static void RemoveFirstEntryIfNotKeywordStarting(string text, string firstKeyword, List<string> splt)
        {
            if (splt.Any() && !text.StartsWith(firstKeyword))
                splt.RemoveAt(0);
        }

        private static List<string> SplitTextByKeyword(string text, string firstKeyword)
        {
            var splt = text.Split(new[] {firstKeyword}, StringSplitOptions.None).ToList();
            return splt;
        }
    }
}

